#ifndef _INC_DEF_HPP
#define _INC_DEF_HPP
#ifdef TC_PS_DLL
	#define TC_PS_EXPORT	__declspec(dllexport)
#else
	#define TC_PS_EXPORT	__declspec(dllimport)
#endif
#define TC_PS_THROW_FUNC	throw()
typedef long TCPsRetCode;
#define	rcOk					0
#define	rcNullArg				1
#define	rcLoadDrvFail			50
#define rcDrvEntryFail			51
#define	rcReregisterDS			52
#define	rcDSNotFound			53
#define	rcDSDError				100
#define rcDSDWrongHandle		101
#define	rcNullClass				200
#define	rcNullCltnImpl			201
#define	rcTxResumeAlien			300
#define	rcObjNotFound			400
#define	rcMissingRelation		401
#define	rcDuplicateObj			402
#define	rcRelationNotDef		403
#define	rcCreateObjFail			404
#define	rcImplNotFound			406
#define	rcCltnNotFound			407
#define	rcObjsNotRelated		408
#define	rcNullObj				409
#define	rcMany2OneNotDef    	410
#define	rcFuncSeqError			411
#define	rcWrongCID				412
#define	rcNullOID				413
#define rcAttribNotExists		414
#define	rcMemberSyntax			500
#define	rcMemberNotFound		501
#define	rcMemberWrongPath		502
#define	rcMemberCltnAsAttrib	503
#define	rcPredTypeMismatch		504
#define	rcQryDestMismatch		505
#define	rcWrongQryDest			506
#define	rcGenOidNotFound		600
#define	rcNoCurrentTx			700
#define	rcTxInNotProperState	701
#define	rcUnexpectedDisconnect	702
#define rcQueryTransientClass	800
#define	rcPersistRef2Transient	801
#define rcPsDerivedFromTrans	802
#define rcUIDefValTypeMismatch	900
#define rcUIValSetTypeMismatch	901
#define rcUIAttribCantHaveData	902

#define rcUserError				2000
// NOTE: after adding errors here put their processing into 'tcPsErrorString' function
enum TCPsDepthMode {
 Depth_Default,
 Depth_Shallow,
 Depth_Deep,
};
enum TCPsSetOpt {
 opt_Clear,
 opt_Set,
};
enum TCPsLockMode {
 Lock_Read,
 Lock_Write,
};

#endif // _INC_DEF_HPP
