#ifndef _INC_EXCEPTN_HPP
#define _INC_EXCEPTN_HPP

// **********************************************************************
class TC_COREEX_EXPORT TC_CException 
{
public:   TC_CException () 
{
} // end of func
// **********************************************************************

public:   TC_CException (const TC_CException&) 
{
} // end of func
// **********************************************************************

public: virtual  ~TC_CException () 
{
} // end of func
// **********************************************************************

public:  TC_CException & operator = (const TC_CException&) 
{
return *this;
} // end of func
// **********************************************************************


}; // end of class TC_CException

// **********************************************************************
enum TCExceptionType {
 ExType_NoEx,
 ExType_Known,
 ExType_Other,
};

// **********************************************************************
struct TC_COREEX_EXPORT TC_CExHolder 
{

// **********************************************************************
public: 
struct Exception 
{
public:  char * name ;
public:  void * value ;

}; // end of class Exception

// **********************************************************************
public:  TCExceptionType m_Type ;
public:  Exception m_Ex ;
public:   TC_CExHolder ()  ;
public:   ~TC_CExHolder ()  ;
public:  void Set (char * name, TC_CException * ex)  ;
public:  TC_CException * Get ()  ;
public:  char * GetName ()  ;
public:  void Reset ()  ;
public:  void SetVal (TCExceptionType type, char *name, void * val, int val_size)  ;
public:  void * GetVal ()  ;
public:  BOOL IsRaized () 
{
return m_Type != ExType_NoEx;
} // end of func
// **********************************************************************

public:  BOOL IsOk () 
{
return m_Type == ExType_NoEx;
} // end of func
// **********************************************************************


}; // end of class TC_CExHolder

// **********************************************************************

#endif // _INC_EXCEPTN_HPP
