#ifndef _INC_UI_HPP
#define _INC_UI_HPP
#define TC_PS_AUI_AGENT			0x00000001
#define TC_PS_AUI_SUPERAGENT	0x00000002
#define TC_PS_AUI_HIDDEN		0x00000004
#define TC_PS_AUI_READONLY		0x00000008
#define TC_PS_UIVAL(val)	TC_CPsAttribUIData::CreatePsBuffer(TC_CPsBuffer((val)))
#define TC_PS_UIVAL_PAIR(val, assoc) { TC_PS_UIVAL((val)), (assoc) }
#define TC_PS_ATTRIB_UI_DATA(c,a)	TC_CPsClassInfo((c)).GetAttribInfo((a))->m_UIData
#define TC_PS_SET_ATTRIB_UI_DATA(cl, at) tcPsAssignAttribUI(##cl##_Class,#at, &##cl##::_##at)

// **********************************************************************
class TC_PS_EXPORT TC_CPsUIFormats 
{
public:  static  TCArrayStrStrNum m_Types ;
public:   TC_CPsUIFormats ()  ;
private: static void Init ()  ;
public: static void Set (int at_type, const char * in, const char * out)  ;
public: static const char * GetIn (int at_type)  ;
public: static const char * GetOut (int at_type)  ;

}; // end of class TC_CPsUIFormats

// **********************************************************************

// **********************************************************************
struct TC_PS_EXPORT TC_CPsAttribUIData 
{

// **********************************************************************
public: 
struct PsValuePair 
{
public:  TC_CPsBuffer * m_Value ;
public:  const char * m_Assoc ;

}; // end of class PsValuePair

// **********************************************************************
public:  long m_Flags ;
public:  TC_CPsBuffer * m_DefVal ;
public:  const char * m_InFmt ;
public:  const char * m_OutFmt ;
public:  const char * m_RscName ;
public:  PsValuePair m_ValueSet [];
public:  int ValSetCount ()  ;
public:  int GetValSetIdx (TC_CPsBuffer & val)  ;
public:  TC_CPsBuffer * GetValSetVal (int idx)  ;
public:  const char * GetValSetAssoc (int idx)  ;
public: static TC_CPsBuffer * CreatePsBuffer (TC_CPsBuffer & ps_buf) 
{
TC_CPsBuffer * pb = new TC_CPsBuffer(ps_buf);
return pb;
} // end of func
// **********************************************************************


}; // end of class TC_CPsAttribUIData

// **********************************************************************
TC_PS_EXPORT int tcPsTypeToBase (int ps_type)  ;
TC_PS_EXPORT TCPsRetCode tcPsAssignAttribUI (TCPsHClass hClass, const char * attr_name, TC_CPsAttribUIData * attr_data) TC_PS_THROW_FUNC ;

#endif // _INC_UI_HPP
