#ifndef _INC_USEGDI_HPP
#define _INC_USEGDI_HPP
#ifdef BUILD_TCCORE
#define TCCORELIB __declspec(dllexport)
#else
#ifdef BUILD_LOCAL
#define TCCORELIB
#else
#define TCCORELIB __declspec(dllimport)
#endif
#endif
TCCORELIB HBRUSH tcUseBrush (COLORREF color)  ;
TCCORELIB HBITMAP tcUseBitmapRc (HANDLE hInst, LPCSTR name_)  ;
TCCORELIB HBITMAP tcUseBitmapBuf (LPCSTR buffer)  ;
TCCORELIB void tcUseBitmapHdr (HBITMAP bmp)  ;
TCCORELIB HIMAGELIST tcUseImageListRc (HANDLE hInst, LPCSTR name_,int cx,DWORD mask=-1)  ;
TCCORELIB HIMAGELIST tcUseImageListBuf (LPCSTR buffer, int cx, DWORD mask=-1)  ;
TCCORELIB void tcUseImageListHdr (HIMAGELIST hil)  ;
TCCORELIB HCURSOR tcUseCursorRc (HANDLE hInst, LPCSTR name_)  ;
TCCORELIB void tcUseCursorHdr (HCURSOR cur)  ;
TCCORELIB HFONT tcUseScrnFont (LPCSTR name)  ;
TCCORELIB char* tcGetUsedFont (HFONT hfont)  ;

// **********************************************************************
class TCCORELIB TC_CChooseFont 
{
public:  TC_CString Name ;
public:  int Size ;
public:  int Attr ;
public:   TC_CChooseFont ()  ;
public:  BOOL Run (HWND hWndPar=0)  ;
public: static BOOL SplitName (LPCSTR src, TC_CString &name, int *size, int *attr)  ;

}; // end of class TC_CChooseFont

// **********************************************************************

#endif // _INC_USEGDI_HPP
