struct TCRPFIELD
{
	long	x;
	long	cx;
	long	pict_cy;
	DWORD	bord_type;

	DWORD	fColor;
	DWORD	bColor;
	DWORD	color1;
	DWORD	color2;
	DWORD	color3;
	DWORD	color4;

// bool
	unsigned	isPict	: 8;
	unsigned	wrap	: 8;
	unsigned	noRepeat: 8;
	unsigned	noRepPg	: 8;
	unsigned	exp_row	: 8;

// int
	unsigned	stretch	: 8;
	unsigned	bord_l	: 8;
	unsigned	bord_r	: 8;
	unsigned	bord_t	: 8;
	unsigned	bord_b	: 8;
	unsigned	h_align	: 8;
	unsigned	v_align	: 8;
};

struct TCRPROW
{
	long		height0;
	DWORD		bord_type;

// bool
	unsigned	suppress	: 8;
	unsigned	page_brk	: 8;
	unsigned	page_split	: 8;
	unsigned	add2bottom	: 8;

// int
	unsigned	bord_l	: 8;
	unsigned	bord_r	: 8;
	unsigned	bord_t	: 8;
	unsigned	bord_b	: 8;
};
struct TcRp1CreateStruct
{
	DWORD	pg_type;
	DWORD	pg_orient;

	RECT	indent;

	DWORD	proc;
	DWORD	user;

	DWORD	work_type;	// 0-Preview, 1-Print
	HWND	hwnd;

	char	docName [ 256 ];
	char	infoText [ 256 ];
};
struct TcRp1BlockOptsStruct
{
	unsigned	keep_all	: 1;
	unsigned	keep_det	: 1;
	unsigned	keep_ftr	: 1;
};

struct TcRp1AddFieldStruct
{
	TCRPFIELD	f;
	char	name [32];
	LOGFONT	lf;
};

struct TcRp1SetImageStruct
{
	char name [ 32 ];
	char * data;
};

struct TcRp1AddRowStruct
{
	TCRPROW  f;

	unsigned  block		: 8; // 0/1/2

	char	name [32];
	char	sub_name [32];
};

struct TcRp1PaintStruct
{
	HDC hDC;
	SIZE	all_pix;
	SIZE	all_unit;
	POINT	off_pix;
	POINT	off_unit;
	SIZE	dr_pix;
	SIZE	dr_unit;
	SIZE	dpi;
};
typedef DWORD (* TCRP1_PROC)(DWORD obj,DWORD cmd,DWORD arg);

enum
{
	TcRp1M_NONE,
	TcRp1M_CREATE,		// TcRp1CreateStruct *; Return h_Dll_Object
	TcRp1M_DESTROY,		// 

	TcRp1M_VIEW_PAGE,	// number; retrun number

	TcRp1M_BLOCK_OPTS,	// TcRp1BlockOptsStruct *
	TcRp1M_ADDROW,		// TcRp1AddRowStruct *
	TcRp1M_ADDFIELD,	// TcRp1AddFieldStruct *
	TcRp1M_ADDVAR,		// char *
	TcRp1M_ADDTEXT,		// char *

	TcRp1M_SET_VAR,			// char [] = "VarName\0VarValue\0"
	TcRp1M_SET_IMG,			// TcRp1SetImageStruct *
	TcRp1M_GET_IMGSIZE,		// char name[]; Return MAKELONG(cx,cy)

	TcRp1M_PRINT,
	TcRp1M_GET_PAINT,		// TcRp1PaintStruct
};

enum
{
	TcRp1E_NONE,
	TcRp1E_EXECUTE,			// char * name
	TcRp1E_FETCH_NEXT,		// char * name; Return OK
	TcRp1E_PAINT_BEGIN,		// TcRp1PaintStruct
	TcRp1E_PAINT_END,		// TcRp1PaintStruct

	TcRp1E_SET_BITMAP,		// (Preview mode) HBITMAP
	TcRp1E_DRAW_BITMAP,		// (Preview mode)

	TcRp1E_PRINT_DONE,		// (Print mode) 1-break, 2-error
	TcRp1E_PRINT_WAIT,		// (Print mode) BOOL wait

	TcRp1E_THREAD_ENTER,
	TcRp1E_THREAD_EXIT,
};
//////////////////////////////////////////////////

