#ifndef _INC_BLOB_HPP
#define _INC_BLOB_HPP

// **********************************************************************
struct TC_COREEX_EXPORT TC_BlobStruct 
{
public:  ULONG _size ;
public:  char * _buffer ;

}; // end of class TC_BlobStruct

// **********************************************************************

// **********************************************************************
class TC_COREEX_EXPORT TC_CBlob 
{
protected:  ULONG m_Size ;
protected:  char * m_Buffer ;
protected:  void _Copy (char * data)  ;
protected:  void _Release ()  ;
protected:  void _Alloc ()  ;
protected:  void _Assign (const TC_CBlob & blob)  ;
public:   TC_CBlob (ULONG size = 0, char * data = 0)  ;
public:   ~TC_CBlob ()  ;
public:   operator const TC_BlobStruct () const ;
public:  TC_CBlob & operator = (const TC_CBlob & blob)  ;
public:  void operator = (const TC_BlobStruct& bs)  ;
public:  ULONG Size ()  ;
public:  char* Buffer () const ;
public:  void Clear ()  ;

}; // end of class TC_CBlob

// **********************************************************************

#endif // _INC_BLOB_HPP
