#ifndef _INC_REGISTRY_HPP
#define _INC_REGISTRY_HPP
#ifdef BUILD_TCCORE
#define TCCORELIB __declspec(dllexport)
#else
#ifdef BUILD_LOCAL
#define TCCORELIB
#else
#define TCCORELIB __declspec(dllimport)
#endif
#endif
TCCORELIB HKEY tcReg_OpenKey (HKEY k, LPCSTR path)  ;
TCCORELIB void tcReg_SetValue (HKEY hkey, LPCSTR name, LPCSTR val)  ;
TCCORELIB BOOL tcReg_NextValue (HKEY hkey, int num, TC_CString &name, TC_CString &val)  ;

// **********************************************************************
class TCCORELIB TC_CRegistry 
{
public: static TC_CString& Str (HKEY k, LPCSTR path, LPCSTR name)  ;
public: static TCArrayCHAR& Bin (HKEY k, LPCSTR path, LPCSTR name)  ;
public: static TC_CArrayString* EnumStr (HKEY k, LPCSTR path)  ;
public: static void UnuseEnumStr (HKEY k, LPCSTR path)  ;
public: static TCArrayStrStr* Section (HKEY k, LPCSTR path)  ;
public: static TCArrayStrArr* SectionBin (HKEY k, LPCSTR path)  ;
public: static void Flush ()  ;
public: static void Keys (HKEY k, LPCSTR path, TC_CArrayString &dst)  ;
private:  static  char* m_Buf ;
private:  static  char m_Name [1024];
private: static int _Value (HKEY hkey, int num, int *plen=0)  ;

}; // end of class TC_CRegistry

// **********************************************************************

#endif // _INC_REGISTRY_HPP
