#ifndef _INC_WUTILS_HPP
#define _INC_WUTILS_HPP
#ifdef BUILD_TCCORE
#define TCCORELIB __declspec(dllexport)
#else
#ifdef BUILD_LOCAL
#define TCCORELIB
#else
#define TCCORELIB __declspec(dllimport)
#endif
#endif
typedef TC_TArrayC <HWND>	TCArrayHWND;
typedef TC_TArrayC <HANDLE>	TCArrayHANDLE;
typedef TC_TArrayC <SIZE>	TCArraySIZE;
typedef TC_TArrayC <POINT>	TCArrayPOINT;
typedef TC_TArrayC <RECT>	TCArrayRECT;

// **********************************************************************
class TCCORELIB TC_CHWndObjMap 
{
public:

struct h2pStruct
{
	HWND	hwnd;
	void	*ptr;
};

typedef TC_TArrayC <h2pStruct> h2pClct;
public:  h2pClct h2p [256];
public:  void* Ptr (HWND hwnd)  ;
public:  void Add (HWND hwnd, void *ptr)  ;
public:  void Del (HWND hwnd)  ;

}; // end of class TC_CHWndObjMap

// **********************************************************************

// **********************************************************************
class TCCORELIB TC_CWaitCursor 
{
private:  static  int m_Count ;
public:   TC_CWaitCursor ()  ;
public:   ~TC_CWaitCursor ()  ;
public: static void Check ()  ;

}; // end of class TC_CWaitCursor

// **********************************************************************
TCCORELIB BOOL tcIsWindowVisible (HWND hWnd)  ;
TCCORELIB BOOL tcIsWindowDisabled (HWND hWnd)  ;
TCCORELIB BOOL tcIsWindowAccessible (HWND hWnd)  ;
TCCORELIB BOOL tcIsMDIMaximized (HWND hmdi)  ;
TCCORELIB void tcGetWindowText (HWND hwnd, TC_CString &ts)  ;
TCCORELIB TC_CString tcGetWindowText (HWND hwnd)  ;
TCCORELIB void tcGetScrollPos (HWND hWnd, int *p_x, int *p_y)  ;
TCCORELIB void tcGetMyChildren (HWND hWnd, TCArrayHWND &arr)  ;
TCCORELIB void tcGetAllChildren (HWND hWnd, TCArrayHWND &arr)  ;
TCCORELIB BOOL tcGetMyChildrenBounds (HWND hWnd, RECT *prc)  ;
TCCORELIB void tcGetOwnedPopups (HWND hWnd, TCArrayHWND &arr)  ;
TCCORELIB void tcGetTaskWindows (TCArrayHWND &arr)  ;
TCCORELIB SIZE tcGetClientSize (HWND hWnd)  ;
TCCORELIB SIZE tcGetWindowSize (HWND hwnd)  ;
TCCORELIB void tcGetChildRect (HWND hwnd,RECT * rc)  ;
TCCORELIB void tcGetTextCxCy (HFONT hfont, int &cx, int& cy)  ;
TCCORELIB void tcStd_Wm_Scroll (BOOL b_vert, HWND hWnd, WPARAM wParam, int isize=1)  ;
TCCORELIB void tcStd_Check_SB (HWND hWnd, int ex_cx, int ex_cy, int isz_x=1, int isz_y=1)  ;
TCCORELIB void tcCheckScroll4Visible (HWND hwndP, HWND hwndC, UINT opt)  ;
TCCORELIB void tcDestroyMyChildren (HWND hWnd)  ;
TCCORELIB void tcRedrawMyChildren (HWND hWnd)  ;
TCCORELIB void tcRadioGrp_SetValue (HWND hwnd, int val)  ;
TCCORELIB int tcRadioGrp_GetValue (HWND hwnd)  ;
TCCORELIB int tcTabCtrl_InsertItem (HWND hWnd, LPSTR text, int index=-1, int imgidx=-1)  ;
TCCORELIB void tcTabCtrl_ShowArea (HWND hWnd, int new_idx)  ;
TCCORELIB void tcTabCtrl_ShowArea (HWND hWnd, HWND hWndArea)  ;
TCCORELIB void tcTabCtrl_OnSize (HWND hWnd)  ;
TCCORELIB BOOL tcInitFocus (HWND hWnd)  ;
TCCORELIB void tcDrawItem (LPARAM lp, LPCSTR text, HIMAGELIST hil=0, int iidx=-1, COLORREF *colors=0)  ;

#endif // _INC_WUTILS_HPP
