#ifndef _INC_TCPSFORM_HPP
#define _INC_TCPSFORM_HPP

#include <TcPch.hpp>
#include <Lio.hpp>
#include <TcWinExt.hpp>
#include <TcPSmith.hpp>

#include <TcTable.h>
#include <TcTree.h>

#include <PfUtils.hpp>
#include <PfForm.hpp>
#include <PfQuery.hpp>

#define TC_CF_Tree			0x00000001
#define TC_CF_ShowOID		0x00000002
#define TC_CF_ShowRelOIDs	0x00000004
#define TC_HATTRIB_CID	((TCPsHAttrib)-1)
#define TC_HATTRIB_OID	((TCPsHAttrib)-2)
#define TC_DEFAULT_DS	"TwoTier"
#define TC_LIMIT_AttribBuf	255
#define TC_LIMIT_ClsName 64
#define TC_MIN_ThreadRows	25
#define WM_USER_POPULATE_DONE	WM_USER+778
#define	WM_USER_POPULATE_STATUS WM_USER+779
#define	TC_SIZE_ForWrap	64
#define	TC_SIZE_ForML	255
#define TC_EVENT_KillThread	"KillThrd"
#define TC_EVENT_FormatText	"FrmtText"
#define TC_EVENT_ObjAction	"ObjActio"
#define TC_EVENT_ChangeMenu	"ChngMenu"
#define TC_REG_Login	"Login"
#define TC_REG_Server	"Server"
#define TC_REG_User		"User"
#define TC_REG_Database	"Database"

#define TC_REG_Frame	"Frame\\"
#define TC_REG_History	"History\\"

#define TC_REG_PfTables		"PfTables"
#define TC_REG_AidPrefix	"Aid"
#define TC_REG_LatestOID	"OID"

#endif // _INC_TCPSFORM_HPP
